#include <gtk/gtk.h>

#include <stdio.h>
#include <stdlib.h>


#include <dbui-defs.h>

#include <dbui-structs.h>

#include "create_table_ui.h"
#include "create_tree_entry.h"
#include "select_tree_item_callback.h"
#include "table_functions.h"

#include "function_prototypes.h"

GtkWidget *
create_result_window(GList	*result_set)
{
    COLUMN	*col = NULL;
    GList	*row = NULL;
    GtkWidget	*window = NULL;
    GtkWidget	*scrolled_window = NULL;
    GtkWidget	*clist = NULL;
    int		num_fields = 0;
    int		i = 0;
    int		x = 0;
    char	**titles = NULL;
    char	**values = NULL;
    char	entry_number[24];

    if(!result_set || !result_set->data)
	return NULL;

    row = result_set->data;

    if(!row || !row->data)
	return NULL;

    num_fields = g_list_length(row);

    titles = (char **)malloc(sizeof(char *) * (num_fields + 1));

    values = (char **)malloc(sizeof(char *) * (num_fields + 1));

    i = 1;

    titles[0] = "Tuple";

    while(row) 
	{
	col = row->data;

	if(col)
	  {
	  titles[i] = col->name;
	  i++;
	  }

	row = g_list_next(row);
	}

    window = gtk_window_new(GTK_WINDOW_TOPLEVEL);

    gtk_widget_set_usize(GTK_WIDGET(window),500,160);

    gtk_widget_show(window);

    scrolled_window = gtk_scrolled_window_new(NULL,NULL);

    gtk_widget_show(scrolled_window);

    clist = gtk_clist_new_with_titles(num_fields + 1,titles);

    gtk_object_set_data(GTK_OBJECT(window),"scrolled_window",scrolled_window);

    gtk_object_set_data(GTK_OBJECT(window),"clist",clist);

    gtk_widget_show(clist);

    gtk_scrolled_window_add_with_viewport(GTK_SCROLLED_WINDOW(scrolled_window),
						clist);

    gtk_container_add (GTK_CONTAINER (window),scrolled_window);

    for(i = 0 ; i < num_fields + 1; i++)
	{
	gtk_clist_set_column_auto_resize(GTK_CLIST(clist),i,TRUE);

	gtk_clist_set_column_min_width(GTK_CLIST(clist),i,40);
	}
    x = 1;

    while(result_set)
	{
	row = result_set->data;

	i = 1;

	while(row)
	  {
	  values[i] = NULL;
	  col = row->data;
	  if(col)
		{
	  	values[i] = col->value; 
		}
	  i++;

	  row = g_list_next(row);

	  }
	sprintf(entry_number,"%i",x);

	values[0] = entry_number;

	x++;

	gtk_clist_append(GTK_CLIST(clist),values);

	result_set = g_list_next(result_set);

	}

    free(titles);
    free(values);

    gtk_widget_show_all(window);

    return window;
}
