#include <gtk/gtk.h>

#include <stdio.h>
#include <stdlib.h>

#include <string.h>

#include <dbui-defs.h>

#include <dbui-structs.h>

#include "function_prototypes.h"

static gint
my_compare_func(gconstpointer a,gconstpointer b);

void
drop_field_callback(GtkMenuItem *menu_item,gpointer data)
{
    GtkWidget   *ctree;
    GtkWidget	*main_window;
    GtkWidget	*g_table;
    GtkWidget	*label;
    GtkWidget	*option_menu;
    GtkWidget	*hbox;
    GtkWidget	*entry;
    GtkWidget	*widg;
    GtkCTreeNode *node;
    GtkCTreeNode *parent;
    GtkCTreeNode *sibling;
    GtkCTreeRow	*row;
    GtkTableChild *table_child;
    GList	*g_l;
    GList	*entry_list;
    GList	*entry_copy;
    GList	*table_children;
    TABLE       *t;
    TABLE	*t2;
    COLUMN	*col;
    COLUMN	*col2;
    CONNECTION	*connect;
    DRIVER	*driver_p;
    char	parent_name[NAME_LENGTH];
    char	name[NAME_LENGTH];
    char	*p;
    int		len_diff;
    int		table_row = 0;
    int		num_cols = 0;
    int		x,y;


    node = gtk_object_get_data(GTK_OBJECT(data),"MY_DATA");

    if(!node )
        return;

    ctree = gtk_object_get_data(GTK_OBJECT(data),"ctree");

    if(node && ctree)
        {
        t = gtk_ctree_node_get_row_data (GTK_CTREE(ctree),node);

	t2 = t->parent;

	g_table = gtk_object_get_data(GTK_OBJECT(t2->window),"my_table");

	entry_list = gtk_object_get_data(GTK_OBJECT(g_table),"ENTRY_LIST");

	g_l = t2->col_set;

	p = strchr(t->name,'.');

	if(p)
	  {
	  len_diff = (int)p - (int)t->name ;

	  memcpy(parent_name,t->name,len_diff );

	  parent_name[len_diff] = '\0';

	  strncpy(name,t->name + len_diff  + 1,NAME_LENGTH);

	  }

	while(g_l)
	  {
	  col = g_l->data;

	  if(t->my_col == col)
	     {
		g_l = NULL;	
	     }
	  else
		g_l = g_list_next(g_l);

	  }

	g_l = entry_list;

	while(g_l)
	  {
	  entry = g_l->data;	  

	  col2 = gtk_object_get_data(GTK_OBJECT(entry),"COLUMN");

	  if(col2  == t->my_col)
		g_l = NULL;
	  else
		g_l = g_list_next(g_l);

	  }

	if(entry)
	  {
	  num_cols = g_list_length(entry_list);

	  entry_copy = g_list_copy(entry_list);

	  entry_copy = g_list_remove(entry_copy,entry);

	  gtk_object_set_data_full(GTK_OBJECT(g_table),"ENTRY_LIST",entry_copy,(GtkDestroyNotify)g_list_free);

	  }

	if(entry)	
		t2->col_set = g_list_remove(t2->col_set,col);

	if(entry)
		hbox = gtk_object_get_data(GTK_OBJECT(entry),"ALIGN");

	if(entry)
		label = gtk_object_get_data(GTK_OBJECT(entry),"ALIGN2");

	if(entry)
		option_menu = gtk_object_get_data(GTK_OBJECT(entry),"OPTION_MENU");

	if(entry)
		gtk_ctree_remove_node(GTK_CTREE(ctree),node);

	if(hbox)
	  {
          table_children = GTK_TABLE(g_table)->children;

          while(table_children)
            {
            table_child = table_children->data;

            if(table_child->widget == hbox)
                {
                table_row = table_child->bottom_attach;

                table_children = NULL;
                }
            else
                table_children = g_list_next(table_children);

            }

	  gtk_container_remove(GTK_CONTAINER(g_table),hbox);
	  }

	if(label)
		gtk_container_remove(GTK_CONTAINER(g_table),label);

	if(option_menu)
		gtk_container_remove(GTK_CONTAINER(g_table),option_menu);

	/* We have to go move them up */
	if(num_cols > table_row)
	  {
	  table_children = g_list_copy(GTK_TABLE(g_table)->children);

	  table_children = g_list_sort(table_children,my_compare_func);

	  while(table_children)
	   {

	   table_child = table_children->data;

	   if(table_child->bottom_attach > table_row)
	     {

	     y = table_child->bottom_attach;

	     x = table_child->right_attach;

	     widg = table_child->widget;

	     gtk_widget_ref(widg);

	     gtk_container_remove(GTK_CONTAINER(g_table),widg);

	     gtk_table_attach_defaults(GTK_TABLE(g_table),widg,
			x - 1, x , y - 2 , y - 1);

	     gtk_widget_unref(widg);

	     }

	   table_children = g_list_next(table_children);
	   }

	  }

	}
}


static gint
my_compare_func(gconstpointer a,gconstpointer b)
{
    GtkTableChild *table_child_a;
    GtkTableChild *table_child_b;

    table_child_a = (GtkTableChild *)a;
    table_child_b = (GtkTableChild *)b;

    if(table_child_a->top_attach > table_child_b->top_attach)
	{
	return 1;
	}

return -1;
}
