#include <gtk/gtk.h>

#include <stdio.h>
#include <string.h>

#include <dbui-defs.h>

#include <dbui-structs.h>

#include <mysql/mysql.h>

#include <mysql-prototypes.h>

#include "../gui/function_prototypes.h"


void
mysql_build_database(TABLE	*database)
{
    MYSQL_RES	*result_set;
    MYSQL_ROW	row;
    CONNECTION	*connect;
    TABLE	*new_table;
    int 	num_rows;
    int		i;
    GList	*g_l;
    

    connect = database->my_connect;

    if(! mysql_select_db((MYSQL *)connect->handle,database->name) )
	{

	result_set = mysql_list_tables((MYSQL *)connect->handle,NULL);

	if(!result_set)
	  {
	  return;
	  }

	num_rows = mysql_num_rows(result_set);

    	for(i = 0 ; i < num_rows ; i++)
	  {
	    row = mysql_fetch_row(result_set);

	    new_table = create_new_table(row[0],connect,database);

	    new_table->menu_type = TABLE_MENU;

	    database->tables = g_list_append(database->tables,new_table);
	  }	
	mysql_free_result(result_set);
	}

    g_l = database->tables;

    while(g_l)
	{
	mysql_build_table(g_l->data);

	g_l = g_list_next(g_l);
	}
}
