#include <gtk/gtk.h>

#include <stdio.h>
#include <string.h>

#include <dbui-defs.h>

#include <dbui-structs.h>

#include <mysql/mysql.h>

#include <mysql-prototypes.h>


CONNECTION *
mysql_login(GList	*fields)
{
    MYSQL	*mysql_conn = NULL;
    CONNECTION	*connect = NULL;
    COLUMN	*col = NULL;
    GList	*g_p = NULL;
    char	*hostname = NULL;
    char	*username = NULL;
    char	*password = NULL;
    char	*database = NULL;
    char	*unix_sock = NULL;
    int		port = 0;
    int		name_len = 0;

    mysql_conn = mysql_init(NULL);

    connect = (CONNECTION *)malloc(sizeof(CONNECTION));

    connect->cols = fields;

    g_p = fields;

    while(g_p)
	{
	col = (COLUMN *)g_p->data;

	if(!strncmp(col->name,"Hostname",strlen("Hostname")))
	  {
	  hostname = col->value;

	  }
	else if(!strncmp(col->name,"Username",strlen("Username")))
	  {
	  username = col->value;
	  }
	else if(!strncmp(col->name,"Password",strlen("Username")))
          {
          password = col->value;
          }
	else if(!strncmp(col->name,"Database",strlen("Username")))
          {
          database = col->value;
          }
	else if(!strncmp(col->name,"Port",strlen("Username")))
          {
          port = strtol( col->value, NULL, 10);
          }
        else if(!strncmp(col->name,"Port",strlen("Port")))
          {
          port = strtol( col->value, NULL, 10);
          }
        else if(col->value[0] != '\0' &&!strncmp(col->name,"Unix sock",strlen("Unix sock")))
          {
          unix_sock = col->value;
          }

	g_p = g_list_next(g_p);
	}

    bzero(connect->name,NAME_LENGTH);

    if(username && hostname)
      {
	snprintf(connect->name,NAME_LENGTH / 2,"%s",username);
	name_len = strlen(connect->name);
	snprintf(connect->name + name_len ,NAME_LENGTH /2 ,
				"@%s",hostname);
      }

    mysql_init(mysql_conn);	

    if(!mysql_real_connect(mysql_conn,hostname,username,password,
		database,port,unix_sock,0))
	{
	printf("%s\n",mysql_error(mysql_conn));
	fflush(stdout);
	g_list_free(connect->cols);

	free(connect);
	free(mysql_conn);
	return NULL;
	}

    connect->handle = mysql_conn; 

    return connect;
}
