#include <gtk/gtk.h>

#include <stdio.h>
#include <string.h>

#include <dbui-defs.h>

#include <dbui-structs.h>

#include <dbui-sql-proto.h>

#define SELECT_STATEMENT "SELECT %s FROM %s "

char *
build_select_query(TABLE	*table)
{
    char	*query;
    char	*col_str;
    char	*where_str;
    char	*table_str;
    char	*order_by = NULL;
    char	*limit_str = NULL;
    int		pos;
    int		total_len = 0;

    if(!table || !table->col_set )
	return NULL;

    where_str = get_col_where_clause(table);

    limit_str = get_limit_str(table);

    order_by = get_order_by_str(table);

    table_str = get_col_table_names(table);

    col_str = get_col_full_names_list(table);

    if(col_str && table_str)
	{
	total_len = strlen(SELECT_STATEMENT);
	total_len += strlen(table_str);
	total_len += strlen(col_str);

	if(where_str && strlen(where_str))
	  {
	  total_len +=strlen(where_str) ;
	  }

	if(limit_str)
	  {
	  total_len += strlen(limit_str);
	  }

	if(order_by)
	  total_len += strlen(order_by);

	query = (char *)calloc(total_len , sizeof(char));

	sprintf(query,SELECT_STATEMENT,col_str,table_str);
	
	pos = strlen(query);

	if(where_str && strlen(where_str))
	  {
	  memcpy(query + pos ,where_str,strlen(where_str));
	  pos += strlen(where_str);
	  }

	if(order_by)
	  {
	  memcpy(query + pos ,order_by,strlen(order_by));
	  pos += strlen(order_by);
	  free(order_by);
	  }

        if(limit_str)
          {
          memcpy(query + pos ,limit_str,strlen(limit_str));
          pos += strlen(limit_str);
          free(limit_str);
          }


	}

    if(col_str)
	free(col_str);

    if(where_str)
	free(where_str);

    if(table_str)
	free(table_str);

return query;
}
